## ettercap-0.8.3.1-3.src.tar.gz

=== bundled_deps/curl/CMakeLists.txt ===
# This file provides the 'bundled_curl' target.

# This will build curl using the release that we've included with
# our distribution of ettercap.
include(ExternalProject)
set(CURL_VERSION 7.71.1)
set(CURL_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(CURL_TARGET bundled-curl-${CURL_VERSION}-${CMAKE_BUILD_TYPE})
set(CURL_BUILD_ROOT ${CMAKE_CURRENT_BINARY_DIR}/${CURL_TARGET})

set(CURL_CONFIGURE_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/curl_configure_wrapper.sh)
set(CURL_BUILD_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/curl_build_wrapper.sh)
set(CURL_INSTALL_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/curl_install_wrapper.sh)

set(CURL_PREFIX ${CURL_BUILD_ROOT}/usr)
set(CURL_LIB_DIR ${CURL_PREFIX}/lib)
set(CURL_INCLUDE_DIR ${CURL_PREFIX}/include)

if(NOT OPENSSL_LIBRARIES)
  message(FATAL_ERROR "Cannot build bundled Curl without OpenSSL support enabled")
endif()

if(NOT ZLIB_LIBRARIES)
  message(FATAL_ERROR "Cannot build bundled Curl without zlib")
endif()

find_package(LIBIDN)
if(NOT LIBIDN_FOUND)
  message(FATAL_ERROR "Cannot build bundled Curl without idn")
endif()

find_package(LIBRTMP)
if(NOT LIBRTMP_FOUND)
  message(FATAL_ERROR "Cannot build bundled Curl without rtmp")
endif()

set(CMAKE_THREAD_PREFER_PTHREAD 1)
find_package(Threads REQUIRED)
if(NOT CMAKE_USE_PTHREADS_INIT)
    message(FATAL_ERROR "Cannot build bundled Curl without pthreads")
endif()

# Ensure that we include all the required stuff for linking to libcurl
set(CURL_LIBRARY ${CURL_LIB_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}curl${CMAKE_STATIC_LIBRARY_SUFFIX}
  ${OPENSSL_LIBRARIES}
  ${ZLIB_LIBRARIES}
  ${LIBIDN_LIBRARIES}
  ${RTMP_LIBRARIES}
  )

#Figure out the parent directory for our openssl installation.
get_filename_component(OPENSSL_ROOT_PATH ${OPENSSL_INCLUDE_DIR} PATH)

set(EXPORT_CC ${CMAKE_C_COMPILER})

# -fPIC is required so that we can link in our static library, properly.
# Add the cmake env cflags and all that jazz so we can inherit architectures
# and the like.
set(EXPORT_C_FLAGS ${CMAKE_C_FLAGS} -fPIC)

set(EXPORT_LD_FLAGS ${CMAKE_THREAD_LIBS_INIT})

if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
  set(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG}")
elseif("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
  set(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE}")
endif()

set(EXPORT_PREFIX ${CURL_PREFIX})

# Enable/Disable IPV6
set(EXPORT_IPV6_FLAGS --disable-ipv6)
if(ENABLE_IPV6)
  set(EXPORT_IPV6_FLAGS --enable-ipv6)
endif()

configure_file(${CURL_SOURCE_DIR}/curl_configure_wrapper.sh.in
  ${CURL_CONFIGURE_WRAPPER} @ONLY)
configure_file(${CURL_SOURCE_DIR}/curl_build_wrapper.sh.in
  ${CURL_BUILD_WRAPPER} @ONLY)
configure_file(${CURL_SOURCE_DIR}/curl_install_wrapper.sh.in
  ${CURL_INSTALL_WRAPPER} @ONLY)

#########################

externalproject_add(
  ${CURL_TARGET}
  URL ${CURL_SOURCE_DIR}/curl-${CURL_VERSION}.tar.gz
  BUILD_IN_SOURCE 1
  SOURCE_DIR ${CURL_BUILD_ROOT}/build
  CONFIGURE_COMMAND sh ${CURL_CONFIGURE_WRAPPER}
  BUILD_COMMAND sh ${CURL_BUILD_WRAPPER}
  INSTALL_COMMAND sh ${CURL_INSTALL_WRAPPER}
  UPDATE_COMMAND ""
  )

# Now export our variables to our parent's scope.
set(CURL_VERSION_STRING ${CURL_VERSION} PARENT_SCOPE)
set(CURL_LIBRARY ${CURL_LIBRARY} PARENT_SCOPE)
set(CURL_INCLUDE_DIR ${CURL_INCLUDE_DIR} PARENT_SCOPE)
set(CURL_FOUND TRUE PARENT_SCOPE)
add_custom_target(bundled_curl)
add_dependencies(bundled_curl ${CURL_TARGET})

=== bundled_deps/libnet/CMakeLists.txt ===
# This file provides the 'bundled_libnet' target.

# This will build libnet using the release that we've included with
# our distribution of ettercap.
include(ExternalProject)
set(LIBNET_VERSION 1.2)
set(LIBNET_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBNET_TARGET bundled-libnet-${LIBNET_VERSION}-${CMAKE_BUILD_TYPE})
set(LIBNET_BUILD_ROOT ${CMAKE_CURRENT_BINARY_DIR}/${LIBNET_TARGET})
set(LIBNET_CONFIGURE_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/libnet_configure_wrapper.sh)
set(LIBNET_BUILD_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/libnet_build_wrapper.sh)
set(LIBNET_INSTALL_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/libnet_install_wrapper.sh)

set(LIBNET_PREFIX ${LIBNET_BUILD_ROOT}/usr)
set(LIBNET_LIB_DIR ${LIBNET_PREFIX}/lib)
set(LIBNET_INCLUDE_DIR ${LIBNET_PREFIX}/include)
set(LIBNET_LIBRARY ${LIBNET_LIB_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}net${CMAKE_STATIC_LIBRARY_SUFFIX})

# Configure the Makefile wrapper. The purpose of this wrapper is to set up
# the environment for building libnet. ExternalProject_Add doesn't
# support setting up any sort of environment, nor does it handle arguments to
# BUILD_COMMAND (and others) that contain double-quotes. According to
# the CMake folks, this is the way to do things.
#  ref: http://www.cmake.org/pipermail/cmake/2010-April/036566.html
#
set(EXPORT_CC ${CMAKE_C_COMPILER})

# -fPIC is required so that we can link in our static library, properly.
# Add the cmake env cflags and all that jazz so we can inherit architectures
# and the like.
set(EXPORT_C_FLAGS ${CMAKE_C_FLAGS} -fPIC)

if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
  set(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG}")
elseif("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
  set(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE}")
endif()

set(EXPORT_PREFIX ${LIBNET_PREFIX})

configure_file(${LIBNET_SOURCE_DIR}/libnet_configure_wrapper.sh.in
  ${LIBNET_CONFIGURE_WRAPPER} @ONLY)
configure_file(${LIBNET_SOURCE_DIR}/libnet_build_wrapper.sh.in
  ${LIBNET_BUILD_WRAPPER} @ONLY)
configure_file(${LIBNET_SOURCE_DIR}/libnet_install_wrapper.sh.in
  ${LIBNET_INSTALL_WRAPPER} @ONLY)

#########################

externalproject_add(
  ${LIBNET_TARGET}
  URL ${LIBNET_SOURCE_DIR}/libnet-${LIBNET_VERSION}.tar.gz
  BUILD_IN_SOURCE 1
  SOURCE_DIR ${LIBNET_BUILD_ROOT}/build
  CONFIGURE_COMMAND sh ${LIBNET_CONFIGURE_WRAPPER}
  BUILD_COMMAND sh ${LIBNET_BUILD_WRAPPER}
  INSTALL_COMMAND sh ${LIBNET_INSTALL_WRAPPER}
  UPDATE_COMMAND ""
  )

# Now export our variables to our parent's scope.
set(LIBNET_VERSION ${LIBNET_VERSION} PARENT_SCOPE)
set(LIBNET_LIBRARY ${LIBNET_LIBRARY} PARENT_SCOPE)
set(LIBNET_INCLUDE_DIR ${LIBNET_INCLUDE_DIR} PARENT_SCOPE)
set(LIBNET_FOUND TRUE PARENT_SCOPE)
add_custom_target(bundled_libnet)
add_dependencies(bundled_libnet ${LIBNET_TARGET})

=== bundled_deps/luajit/CMakeLists.txt ===
include(ExternalProject)
set(LUAJIT_VERSION 2.0.5)
set(LUAJIT_TARGET bundled-luajit-${LUAJIT_VERSION}-${CMAKE_BUILD_TYPE})
set(LUAJIT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(LUAJIT_BUILD_ROOT ${CMAKE_CURRENT_BINARY_DIR}/${LUAJIT_TARGET})
set(LUAJIT_BUILD_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/luajit_build_wrapper.sh)
set(LUAJIT_INSTALL_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/luajit_install_wrapper.sh)

set(LUAJIT_PREFIX ${LUAJIT_BUILD_ROOT}/usr)
set(LUAJIT_LIB_DIR ${LUAJIT_PREFIX}/lib)
set(LUAJIT_INCLUDE_DIR ${LUAJIT_PREFIX}/include/luajit-2.0)

# LuaJIT requires both libm and libdl.. Let's find those.

find_library(LIB_M m)
if(NOT LIB_M)
  message(FATAL_ERROR "Could not find libm, which is required by luajit.")
endif()

find_library(LIB_DL dl)
if(NOT LIB_DL)
  message(FATAL_ERROR "Could not find libdl, which is required by luajit.")
endif()


set(LUAJIT_LIBRARY
  ${LUAJIT_PREFIX}/lib/${CMAKE_STATIC_LIBRARY_PREFIX}luajit-5.1${CMAKE_STATIC_LIBRARY_SUFFIX}
  ${LIB_M}
  ${LIB_DL}
  )

# Configure the Makefile wrapper. The purpose of this wrapper is to set up
# the environment for building luajit. ExternalProject_Add doesn't
# support setting up any sort of environment, nor does it handle arguments to
# BUILD_COMMAND (and others) that contain double-quotes. According to
# the CMake folks, this is the way to do things.
#  ref: http://www.cmake.org/pipermail/cmake/2010-April/036566.html
#
set(EXPORT_CC ${CMAKE_C_COMPILER})

# -fPIC is required so that we can link in our static library, properly.
# Add the cmake env cflags and all that jazz so we can inherit architectures
# and the like.
set(EXPORT_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
  set(EXPORT_CCDEBUG "-g")
  # Explicitly disable CCOPT, as we do not want fomit-frame-pointer
  # conflicting with debuggy stuff.
  set(EXPORT_DISABLE_CCOPT CCOPT=)
  set(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG}")
elseif("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
  set(EXPORT_CCDEBUG "")
  set(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE}")
endif()

set(EXPORT_BUILDMODE static)
set(EXPORT_PREFIX ${LUAJIT_PREFIX})

configure_file(${LUAJIT_SOURCE_DIR}/luajit_build_wrapper.sh.in
  ${LUAJIT_BUILD_WRAPPER} @ONLY)
configure_file(${LUAJIT_SOURCE_DIR}/luajit_install_wrapper.sh.in
  ${LUAJIT_INSTALL_WRAPPER} @ONLY)

#########################

externalproject_add(
    ${LUAJIT_TARGET}
    URL ${LUAJIT_SOURCE_DIR}/LuaJIT-${LUAJIT_VERSION}.tar.gz
    BUILD_IN_SOURCE 1
    SOURCE_DIR ${LUAJIT_BUILD_ROOT}/build
    CONFIGURE_COMMAND ""
    BUILD_COMMAND sh ${LUAJIT_BUILD_WRAPPER}
    INSTALL_COMMAND sh ${LUAJIT_INSTALL_WRAPPER}
    UPDATE_COMMAND ""
)

set(LUAJIT_VERSION ${LUAJIT_VERSION} PARENT_SCOPE)
set(LUAJIT_LIBRARY ${LUAJIT_LIBRARY} PARENT_SCOPE)
set(LUAJIT_INCLUDE_DIR ${LUAJIT_INCLUDE_DIR} PARENT_SCOPE)
set(LUAJIT_FOUND TRUE PARENT_SCOPE)

add_custom_target(bundled_luajit)
add_dependencies(bundled_luajit ${LUAJIT_TARGET})

=== src/lua/share/scripts/CMakeLists.txt ===
install(FILES
            inject_http.lua
            inject_http_demo.lua
            get_imap_demo.lua
            tcp_session_demo.lua
            http_creds.lua
            http_requests.lua
            inject_http.lua
            smtp_redir.lua
            geoip_demo.lua
            DESTINATION ${INSTALL_LUA_SCRIPTS})

=== PKGBUILD ===
# Maintainer: Levente Polyak <anthraxx[at]archlinux[dot]org>
# Maintainer: Santiago Torres-Arias <santiago@archlinux.org>
# Contributor: Tom Newsom <Jeepster@gmx.co.uk>

pkgbase=ettercap
pkgname=(ettercap ettercap-gtk)
pkgver=0.8.3.1
pkgrel=3
pkgdesc='Network sniffer/interceptor/logger for ethernet LANs'
url='https://www.ettercap-project.org/'
arch=('x86_64')
license=('GPL')
depends=('glibc' 'openssl' 'zlib' 'libpcap' 'pcre' 'libltdl' 'libnet' 'ethtool' 'curl' 'geoip'
         'ncurses' 'libncursesw.so' 'libformw.so' 'libpanelw.so' 'libmenuw.so' 'libcurl.so')
makedepends=('ghostscript' 'cmake' 'gtk3' 'harfbuzz' 'check')
options=('!emptydirs')
backup=(etc/ettercap/etter.{conf,dns,mdns,nbns})
source=(https://github.com/Ettercap/ettercap/archive/v${pkgver}/${pkgbase}-${pkgver}.tar.gz
        cmake-harfbuzz.patch
        https://github.com/Ettercap/ettercap/commit/40534662.patch)
sha512sums=('9bd71dcc1730293ee83934aca3587dfde662cb3890c12fafa557b6359f12226e5cb6f59a0db1aa11245a132b275e355e3bcc8952db921171d27b792827f148b5'
            '56e75ae2fe6b3761a121d7062133c53d9b15894662c9ce341dd67eb4913983e926975f4a0901e2f2bf1c85933eb45e1842500e1c6a9af4738c761b328b3b8745'
            '232ba10517b4206d13c546a584f742fe69c1514f25ba8d862677840cd433834a31c65c9d7be51eed9437793956e8595d211f9df32405653e69d630d6bca6e4b4')
b2sums=('2680b97454626a6f1af3b21f689ba8eed7a023c3ef5cd84d5b2b5859382f398b3a6fc622270ca41941a8a18a7bdd260af64165344a33b2e195c86ee61567f2eb'
        'da9a1306637e28b5c00b4e2615b999a92d3365f8fad7ba956c10e16e09c1fb8dbe3e529fb70758fc891d8741975026aa167f957316deb814def76014750cc50f'
        'b4ae8882cdb1ed38803a22207b01faeee88646bcac892abfeac20301518380fe0c94dd4644ed626d810648313d5a9ff6d8ddd28f106eaf2fec927db96914dee1')

prepare() {
  cd ${pkgbase}-${pkgver}
  patch -Np1 < "${srcdir}/cmake-harfbuzz.patch"
  patch -Np1 < ../40534662.patch # Fix build with curl 8
}

build() {
  export CFLAGS+=" ${CPPFLAGS}"
  export CXXLAGS+=" ${CPPFLAGS}"

  cd ${pkgbase}-${pkgver}
  cmake -B build \
    -D CMAKE_BUILD_TYPE=Release \
    -D CMAKE_INSTALL_PREFIX=/usr \
    -D INSTALL_PREFIX=/usr \
    -D ENABLE_GTK=OFF \
    -D ENABLE_TESTS=ON \
    -D ENABLE_IPV6=ON
  make -C build VERBOSE=1

  cmake -B build-gtk \
    -D CMAKE_BUILD_TYPE=Release \
    -D CMAKE_INSTALL_PREFIX=/usr \
    -D INSTALL_PREFIX=/usr \
    -D ENABLE_GTK=ON \
    -D ENABLE_TESTS=ON \
    -D ENABLE_IPV6=ON
  make -C build-gtk VERBOSE=1
}

check() {
  cd ${pkgbase}-${pkgver}
  make -C build test
  make -C build-gtk test
}

package_ettercap() {
  pkgdesc+=" - console"
  provides=('libettercap.so')

  cd ${pkgbase}-${pkgver}
  make -C build DESTDIR="${pkgdir}" install
  install -Dm 644 CHANGELOG README* -t "${pkgdir}/usr/share/doc/${pkgname}"
}

package_ettercap-gtk() {
  pkgdesc+=" - GTK frontend"
  depends+=('gtk3' 'harfbuzz')
  optdepends=('polkit: run ettercap directly from menu')
  provides=('ettercap' 'libettercap.so')
  conflicts=('ettercap')

  cd ${pkgbase}-${pkgver}
  make -C build-gtk DESTDIR="${pkgdir}" install
  install -Dm 644 CHANGELOG README* -t "${pkgdir}/usr/share/doc/${pkgname}"
}

# vim: ts=2 sw=2 et:
